Attribute VB_Name = "IE_AutoComplete"
Option Explicit

'==================================================================
'
' Internet Explorer 5 Only: Autocomplete text boxes
'
' 29 September 2001
'
' You're free in using this software, as long as the
' orignal copyright/author information remains intact.
' In other words, respecting the person(s) who made it
' possible for you to view/learn something of this software.
'
' Copyright  2001 - Diederik van der Boor
' http://www.codingdomain.com
'
'==================================================================


Private IEVer As IEVersionInfo


'------------------------------------------------------------------
' API Declarations

Public Enum IEAutoSuggestTypes
  SHACF_AUTOSUGGEST_FORCE_ON = &H10000000  'Ignore registry default and force feature on
  SHACF_AUTOSUGGEST_FORCE_OFF = &H20000000  'Ignore registry default and force feature off.
  SHACF_AUTOAPPEND_FORCE_ON = &H40000000  'Ignore registry default and force feature on. (Also know as AutoComplete)
  SHACF_AUTOAPPEND_FORCE_OFF = &H80000000   'Ignore registry default and force feature off. (Also know as AutoComplete)
  SHACF_DEFAULT = &H0   'Currently (SHACF_FILESYSTEM | SHACF_URLALL)
  SHACF_FILESYSTEM = &H1   'Includes the File System as well as the rest of the shell (Desktop\My Computer\Control Panel\)
  SHACF_URLHISTORY = &H2  'URLs in the User's History
  SHACF_URLMRU = &H4  'URLs in the User's Recently Used list
  SHACF_URLALL = (SHACF_URLHISTORY Or SHACF_URLMRU)
End Enum

Private Declare Function SHAutoComplete Lib "Shlwapi.dll" (ByVal hwndEdit As Long, ByVal dwFlags As Long) As Long


'------------------------------------------------------------------
' Autocomlete

' Works with text and combo boxes. (style: 1 | 0)
Public Sub IEAutoComplete(ControlhWnd As Long, Optional SuggestType As IEAutoSuggestTypes = SHACF_DEFAULT)
  If IEVer Is Nothing Then Set IEVer = New IEVersionInfo
  
  If IEVer.Major >= 5 Then
    'Turn on auto-complete
    If SHAutoComplete(ControlhWnd, SHACF_DEFAULT) = 1 Then _
      Err.Raise 12345, "Auto Complete", "IE failed to set autocomplete to the field!"
  Else
    Err.Raise 12345, "Auto Complete", "Could not use AutoComplete because you don't have IE5 installed on your system!"
  End If
End Sub
